<?php
namespace Claromentis\Infocapture\Subscriber;

$GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"] ?: array()) + array("objec" . "t_id" => base64_decode("b2J" . "qZW" . "N0X" . "2lk"), "agg" . "reg" . "ati" . "on" => base64_decode("YWdn" . "cmVn" . "YXRp" . "b24="), "_085a57daeaa7eb01c5" . "adc7d4956ca1ec" => base64_decode("T25M" . "aWtl"), "_d0407c814" . "a49347e44a" . "eaf3f78569" . "27f" => base64_decode("T25Vbmxpa2U" . "="), "_da9102682d361b8bbba479dd3" . "5a6a5a6" => base64_decode("bGlrZV9jb3VudA" . "=="));
use Claromentis\Core\Event\EventSubscriberInterface;
use Claromentis\Core\Event\GenericEvent;
use Claromentis\Core\Like\LikeEvents;
use Claromentis\Core\Like\LikesRepository;
use HDIssue;




class TicketLikeSubscriber implements EventSubscriberInterface
{
    
    
    
    
    private $likes_repo;
    
    
    
    
    private HDIssue $hd_issue;
    public function __construct(LikesRepository $_d9545fdd786c9a15186743b3fd0af9ff, HDIssue $_4ada5869286e9a58f9116abae0cfae31)
    {
        $this->likes_repo = $_d9545fdd786c9a15186743b3fd0af9ff;
        $this->hd_issue = $_4ada5869286e9a58f9116abae0cfae31;
    }
    public static function getSubscribedEvents() : array
    {
        return [LikeEvents::OBJECT_LIKED => $GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_085a57daeaa7eb01c5adc7d4956ca1e" . "c"], LikeEvents::OBJECT_UNLIKED => $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_d0407c814a49347e44a" . "eaf3f7856927f"]];
    }
    public function OnLike(GenericEvent $event)
    {
        if (!$this->isIssueLikeEvent($event)) {
            return;
        }
        $_7c7f9b97a77342fe69e4b9ce8802e8d1 = $this->updateLikeCountProperty($event->getArgument($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["object_" . "id"]));
    }
    public function OnUnlike(GenericEvent $event)
    {
        if (!$this->isIssueLikeEvent($event)) {
            return;
        }
        $_7c7f9b97a77342fe69e4b9ce8802e8d1 = $this->updateLikeCountProperty($event->getArgument($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["object_" . "id"]));
    }
    
    
    
    
    
    private function updateLikeCountProperty(int $_39638557be821c8556d28efa25c94ff1) : bool
    {
        $_da9102682d361b8bbba479dd35a6a5a6 = $this->likes_repo->GetCount(AGGREGATION_IC_ISSUE, $_39638557be821c8556d28efa25c94ff1);
        $this->hd_issue->Load($_39638557be821c8556d28efa25c94ff1);
        $this->hd_issue->SetProperty($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_da9102682d361b8bbba479dd" . "35a6a5a6"], $_da9102682d361b8bbba479dd35a6a5a6);
        return $this->hd_issue->Save();
    }
    
    
    
    
    
    private function isIssueLikeEvent(GenericEvent $event) : bool
    {
        return $event->hasArgument($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["aggre" . "gatio" . "n"]) && $event->getArgument($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["aggregati" . "on"]) === AGGREGATION_IC_ISSUE;
    }
}